// AviSynth script GNX|[gvOC
#include <windows.h>
#include <shlwapi.h>
#include <stdio.h>
#include "filter.h"

#define FILE_TXT "Script Template (*.txt)\0*.txt\0AllFile (*.*)\0*.*\0"
#define FILE_AVS "Avisynth Script (*.avs)\0*.avs\0Batch File (*.bat)\0*.bat\0AllFile (*.*)\0*.*\0"

FILTER_DLL filter = {
  FILTER_FLAG_EXPORT|FILTER_FLAG_NO_CONFIG|FILTER_FLAG_ALWAYS_ACTIVE|FILTER_FLAG_PRIORITY_LOWEST|FILTER_FLAG_EX_INFORMATION,
  0,0,
  "AviSynth",
  NULL,NULL,NULL,
  NULL,NULL,
  NULL,NULL,NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  func_WndProc,
  NULL,NULL,
  NULL,
  NULL,
  "AviSynth script GNX|[g ver.1.4 by Aji",
  NULL,
  NULL,
};

EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable(void)
{
  return &filter;
}

typedef struct {
  char s[1024];
  int l, n, e;
} PATH_NAME;

static void reset_path(PATH_NAME *dst, char* src)
{
  LPTSTR ptr;
  
  GetFullPathName((LPCTSTR)src, (DWORD)sizeof(dst->s), (LPTSTR)dst->s, &ptr);
  dst->l = (int)lstrlen(dst->s);
  dst->n = (int)(ptr - dst->s);
  
  ptr = PathFindExtension((LPTSTR)dst->s);
  dst->e = (int)(ptr - dst->s);
  
  return;
}

static void add_path(char* dst, PATH_NAME *src)
{
  int i;
  
  while(*dst != 0) dst++;
  for(i = 0; i < src->n; i++) dst[i] = src->s[i];
  dst[i] = 0;
}

static void add_name(char* dst, PATH_NAME *src)
{
  int i;
  
  while(*dst != 0) dst++;
  for(i = src->n; i < src->e; i++) dst[i - src->n] = src->s[i];
  dst[i - src->n] = 0;
}

static void add_ext(char* dst, PATH_NAME *src)
{
  int i;
  
  while(*dst != 0) dst++;
  for(i = src->e; i <= src->l; i++) dst[i - src->e] = src->s[i];
}

static void add_str(char* dst, char *src)
{
  while(*dst != 0) dst++;
  while(*src != 0) *dst++ = *src++;
  *dst = 0;
}

static void output_trim(FILE *fh, void *editp, FILTER *fp)
{
  FRAME_STATUS fs;
  int *index, frame_n, frame_s, frame_e, c, i;
  
  frame_n = fp->exfunc->get_frame_n(editp);
  if(frame_n <= 0) return;
  if(!fp->exfunc->get_select_frame(editp, &frame_s, &frame_e)) return;
  if(frame_s < 0) frame_s = 0;
  if(frame_s >= frame_n) frame_s = frame_n - 1;
  if(frame_e < 0) frame_e = 0;
  if(frame_e >= frame_n) frame_e = frame_n - 1;
  if(frame_s > frame_e) frame_e = frame_s;
  if((index = (int*)malloc(sizeof(int) * frame_n)) == NULL) return;
  
  for(i = frame_s; i <= frame_e; i++){
    if(!fp->exfunc->get_frame_status(editp, i, &fs)){
      MessageBox(NULL, "t[Xe[^X擾Ɏs܂", "AviSynth Script GNX|[g", MB_OK|MB_ICONSTOP);
      free(index);
      return;
    }
    index[i] = fs.video;
    if(i > frame_s){
      if((index[i] >> 24) != (index[i-1] >> 24)){
        MessageBox(NULL, "̃t@CAĂ܂B", "AviSynth Script GNX|[g", MB_OK|MB_ICONSTOP);
        free(index);
        return;
      }
    }
  }
  for(i = frame_s; i <= frame_e; i++)
    index[i] &= 0xffffff;
  
  fprintf(fh, "Trim(%d,", index[frame_s]);
  c = 0;
  for(i = frame_s + 1; i <= frame_e; i++){
    if(index[i] != index[i-1] + 1){
      c++;
      if(c >= 4){
        fprintf(fh, "%d)\n\\++Trim(%d,", index[i-1], index[i]);
        c = 0;
      }else{
        fprintf(fh, "%d)++Trim(%d,", index[i-1], index[i]);
      }
    }
  }
  fprintf(fh, "%d)\n", index[frame_e]);
  
  free(index);
  return;
}

BOOL func_WndProc(HWND, UINT message, WPARAM, LPARAM, void *editp, FILTER *fp)
{
  PATH_NAME pvideo, plastin, plastout, pdefout, ptxt, pavs;
  FILE *fr, *fw;
  int c, p, i;
  FILE_INFO fip;
  int file_id, video_num;
  
  if(!fp->exfunc->is_editing(editp)) return FALSE;
  
  if(message == WM_FILTER_EXPORT){
    if(!fp->exfunc->get_source_video_number(editp, 0, &file_id, &video_num)) return FALSE;
    if(!fp->exfunc->get_source_file_info(editp, &fip, file_id)) return FALSE;
    reset_path(&pvideo, fip.name);
    
    if(!fp->exfunc->ini_load_str(fp, "input_file", plastin.s, "")) return FALSE;
    reset_path(&plastin, plastin.s);
    
    if(!fp->exfunc->ini_load_str(fp, "output_file", plastout.s, "")) return FALSE;
    reset_path(&plastout, plastout.s);
    
    if(!fp->exfunc->dlg_get_load_name(ptxt.s, FILE_TXT, plastin.s)) return FALSE;
    reset_path(&ptxt, ptxt.s);
    
    if((fr = fopen(ptxt.s, "r")) == NULL) return FALSE;
    
    pdefout.s[0] = 0;
    add_path(pdefout.s, &plastout);
    add_name(pdefout.s, &pvideo);
    if(plastout.e == plastout.l)
      add_str(pdefout.s, ".avs");
    else
      add_ext(pdefout.s, &plastout);
    
    if(!fp->exfunc->dlg_get_save_name(pavs.s, FILE_AVS, pdefout.s)) return FALSE;
    reset_path(&pavs, pavs.s);
    
    if((fw = fopen(pavs.s, "w")) == NULL) return FALSE;
    
    p = 0;
    while((c = fgetc(fr)) != EOF){
      if(p == '%'){
        if(c == 't' || c == 'T'){
          output_trim(fw, editp, fp);
        }else if(c == 'V'){
          for(i = 0; i < pvideo.l; i++) fputc(pvideo.s[i], fw);
        }else if(c == 'U'){
          for(i = 0; i < pvideo.n; i++) fputc(pvideo.s[i], fw);
        }else if(c == 'v'){
          for(i = pvideo.n; i < pvideo.l; i++) fputc(pvideo.s[i], fw);
        }else if(c == 'u'){
          for(i = pvideo.n; i < pvideo.e; i++) fputc(pvideo.s[i], fw);
        }else if(c == 'S'){
          for(i = 0; i < pavs.l; i++) fputc(pavs.s[i], fw);
        }else if(c == 'R'){
          for(i = 0; i < pavs.n; i++) fputc(pavs.s[i], fw);
        }else if(c == 's'){
          for(i = pavs.n; i < pavs.l; i++) fputc(pavs.s[i], fw);
        }else if(c == 'r'){
          for(i = pavs.n; i < pavs.e; i++) fputc(pavs.s[i], fw);
        }else{
          fputc(c, fw);
        }
        p = 0;
      }else{
        if(c != '%') fputc(c, fw);
        p = c;
      }
    }
    
    fclose(fr);
    fclose(fw);
    
    fp->exfunc->ini_save_str(fp, "input_file", ptxt.s);
    fp->exfunc->ini_save_str(fp, "output_file", pavs.s);
  }
  
  return FALSE;
}
