// Trim GNX|[gvOC
#include <windows.h>
#include <stdio.h>
#include "filter.h"

FILTER_DLL filter = {
  FILTER_FLAG_EXPORT|FILTER_FLAG_NO_CONFIG|FILTER_FLAG_ALWAYS_ACTIVE|FILTER_FLAG_PRIORITY_LOWEST|FILTER_FLAG_EX_INFORMATION,
  0,0,
  "Trim",
  NULL,NULL,NULL,
  NULL,NULL,
  NULL,NULL,NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  func_WndProc,
  NULL,NULL,
  NULL,
  NULL,
  "Trim GNX|[g ver.1.3 by Aji",
  NULL,
  NULL,
};

EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable(void)
{
  return &filter;
}

static BOOL error_message(FILTER *fp, LPTSTR m)
{
  MessageBox(fp->hwnd, m, "Trim GNX|[g", MB_OK|MB_ICONSTOP);
  return FALSE;
}

BOOL set_clipboard_text(HWND hwnd, char *str)
{
  HANDLE hMem;
  char *mem;
  int l = 0;
  
  while(str[l++]) ;
  if((hMem = GlobalAlloc(GMEM_SHARE|GMEM_MOVEABLE, l)) == NULL) return FALSE;
  
  if((mem = (char*)GlobalLock(hMem)) == NULL){
    GlobalFree(hMem);
    return FALSE;
  }
  memcpy(mem, str, l);
  GlobalUnlock(hMem);
  
  if(!OpenClipboard(hwnd)){
    GlobalFree(hMem);
    return FALSE;
  }
  EmptyClipboard();
  SetClipboardData(CF_TEXT, hMem);
  CloseClipboard();
  
  return TRUE;
}

BOOL func_WndProc(HWND, UINT message, WPARAM, LPARAM, void *editp, FILTER *fp)
{
  char *buf, *ptr;
  FRAME_STATUS fs;
  int *index, frame_n, frame_s, frame_e, c, i;
  
  if(!fp->exfunc->is_editing(editp)) error_message(fp, "GNX|[g͕ҏŴ݉\ł");
  
  if(message == WM_FILTER_EXPORT){
    frame_n = fp->exfunc->get_frame_n(editp);
    if(frame_n <= 0) return error_message(fp, "t[܂");
    if(!fp->exfunc->get_select_frame(editp, &frame_s, &frame_e)) return error_message(fp, "I͈͎擾Ɏs܂");
    if(frame_s < 0) frame_s = 0;
    if(frame_s >= frame_n) frame_s = frame_n - 1;
    if(frame_e < 0) frame_e = 0;
    if(frame_e >= frame_n) frame_e = frame_n - 1;
    if(frame_s > frame_e) frame_e = frame_s;
    if((index = (int*)malloc(sizeof(int) * frame_n)) == NULL) return error_message(fp, "mۂɎs܂");
    
    for(i = frame_s; i <= frame_e; i++){
      if(!fp->exfunc->get_frame_status(editp, i, &fs)){
        free(index);
        return error_message(fp, "t[Xe[^X擾Ɏs܂");;
      }
      index[i] = fs.video;
      if(i > frame_s){
        if((index[i] >> 24) != (index[i-1] >> 24)){
          free(index);
          return error_message(fp, "̃t@CAĂ܂");
        }
      }
    }
    for(i = frame_s; i <= frame_e; i++)
      index[i] &= 0xffffff;
    
    if((buf = (char*)malloc(frame_n * 16)) == NULL){
      free(index);
      return error_message(fp, "mۂɎs܂");
    }
    ptr = buf;
    ptr += wsprintf(ptr, "Trim(%d,", index[frame_s]);
    c = 0;
    for(i = frame_s + 1; i <= frame_e; i++){
      if(index[i] != index[i-1] + 1){
        c++;
        if(c >= 4){
          ptr += wsprintf(ptr, "%d)\n\\++Trim(%d,", index[i-1], index[i]);
          c = 0;
        }else{
          ptr += wsprintf(ptr, "%d)++Trim(%d,", index[i-1], index[i]);
        }
      }
    }
    ptr += wsprintf(ptr, "%d)\n", index[frame_e]);
    
    set_clipboard_text(fp->hwnd, buf);
    
    free(index);
    free(buf);
  }
  
  return FALSE;
}
